# coding: utf-8

"""
    CyborgDB Service

    REST API for CyborgDB: The Confidential Vector Database

    The version of the OpenAPI document: 0.9.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class TrainRequest(BaseModel):
    """
    Request model for training an index.  Attributes:     batch_size (int): Size of each batch for training. Default is 2048.     max_iters (int): Maximum iterations for training. Default is 100.     tolerance (float): Convergence tolerance for training. Default is 1e-6.     max_memory (int): Maximum memory (MB) usage during training. Default is 0 (no limit).
    """ # noqa: E501
    index_key: StrictStr = Field(description="32-byte encryption key as hex string")
    index_name: StrictStr = Field(description="ID name")
    batch_size: Optional[StrictInt] = 2048
    max_iters: Optional[StrictInt] = 100
    tolerance: Optional[Union[StrictFloat, StrictInt]] = 1.0E-6
    max_memory: Optional[StrictInt] = 0
    __properties: ClassVar[List[str]] = ["index_key", "index_name", "batch_size", "max_iters", "tolerance", "max_memory"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TrainRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TrainRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "index_key": obj.get("index_key"),
            "index_name": obj.get("index_name"),
            "batch_size": obj.get("batch_size") if obj.get("batch_size") is not None else 2048,
            "max_iters": obj.get("max_iters") if obj.get("max_iters") is not None else 100,
            "tolerance": obj.get("tolerance") if obj.get("tolerance") is not None else 1.0E-6,
            "max_memory": obj.get("max_memory") if obj.get("max_memory") is not None else 0
        })
        return _obj


