# cyborgdb.openapi-client
REST API for CyborgDB: The Confidential Vector Database

The `cyborgdb.openapi_client` package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.9.0
- Package version: 1.0.0
- Generator version: 7.13.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.9+

## Installation & Usage

This python library package is generated without supporting files like setup.py or requirements files

To be able to use it, you will need these dependencies in your own package that uses this library:

* urllib3 >= 2.1.0, < 3.0.0
* python-dateutil >= 2.8.2
* pydantic >= 2
* typing-extensions >= 4.7.1

## Getting Started

In your own code, to use this library to connect and interact with cyborgdb.openapi-client,
you can run the following:

```python

import cyborgdb.openapi_client
from cyborgdb.openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = cyborgdb.openapi_client.Configuration(
    host = "http://localhost"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: APIKeyHeader
configuration.api_key['APIKeyHeader'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['APIKeyHeader'] = 'Bearer'


# Enter a context with an instance of the API client
with cyborgdb.openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = cyborgdb.openapi_client.DefaultApi(api_client)
    create_index_request = cyborgdb.openapi_client.CreateIndexRequest() # CreateIndexRequest | 

    try:
        # Create Encrypted Index
        api_response = api_instance.create_index_v1_indexes_create_post(create_index_request)
        print("The response of DefaultApi->create_index_v1_indexes_create_post:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DefaultApi->create_index_v1_indexes_create_post: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**create_index_v1_indexes_create_post**](cyborgdb/openapi_client/docs/DefaultApi.md#create_index_v1_indexes_create_post) | **POST** /v1/indexes/create | Create Encrypted Index
*DefaultApi* | [**delete_index_v1_indexes_delete_post**](cyborgdb/openapi_client/docs/DefaultApi.md#delete_index_v1_indexes_delete_post) | **POST** /v1/indexes/delete | Delete Encrypted Index
*DefaultApi* | [**delete_vectors_v1_vectors_delete_post**](cyborgdb/openapi_client/docs/DefaultApi.md#delete_vectors_v1_vectors_delete_post) | **POST** /v1/vectors/delete | Delete Items from Encrypted Index
*DefaultApi* | [**get_index_info_v1_indexes_describe_post**](cyborgdb/openapi_client/docs/DefaultApi.md#get_index_info_v1_indexes_describe_post) | **POST** /v1/indexes/describe | Describe Encrypted Index
*DefaultApi* | [**get_index_size_v1_vectors_num_vectors_post**](cyborgdb/openapi_client/docs/DefaultApi.md#get_index_size_v1_vectors_num_vectors_post) | **POST** /v1/vectors/num_vectors | Get the number of vectors in an index
*DefaultApi* | [**get_vectors_v1_vectors_get_post**](cyborgdb/openapi_client/docs/DefaultApi.md#get_vectors_v1_vectors_get_post) | **POST** /v1/vectors/get | Get Items from Encrypted Index
*DefaultApi* | [**health_check_v1_health_get**](cyborgdb/openapi_client/docs/DefaultApi.md#health_check_v1_health_get) | **GET** /v1/health | Health check endpoint
*DefaultApi* | [**list_indexes_v1_indexes_list_get**](cyborgdb/openapi_client/docs/DefaultApi.md#list_indexes_v1_indexes_list_get) | **GET** /v1/indexes/list | List Encrypted Indexes
*DefaultApi* | [**query_vectors_v1_vectors_query_post**](cyborgdb/openapi_client/docs/DefaultApi.md#query_vectors_v1_vectors_query_post) | **POST** /v1/vectors/query | Query Encrypted Index
*DefaultApi* | [**train_index_v1_indexes_train_post**](cyborgdb/openapi_client/docs/DefaultApi.md#train_index_v1_indexes_train_post) | **POST** /v1/indexes/train | Train Encrypted index
*DefaultApi* | [**upsert_vectors_v1_vectors_upsert_post**](cyborgdb/openapi_client/docs/DefaultApi.md#upsert_vectors_v1_vectors_upsert_post) | **POST** /v1/vectors/upsert | Add Items to Encrypted Index


## Documentation For Models

 - [BatchQueryRequest](cyborgdb/openapi_client/docs/BatchQueryRequest.md)
 - [Contents](cyborgdb/openapi_client/docs/Contents.md)
 - [CreateIndexRequest](cyborgdb/openapi_client/docs/CreateIndexRequest.md)
 - [CyborgdbServiceApiSchemasIndexSuccessResponseModel](cyborgdb/openapi_client/docs/CyborgdbServiceApiSchemasIndexSuccessResponseModel.md)
 - [CyborgdbServiceApiSchemasVectorsSuccessResponseModel](cyborgdb/openapi_client/docs/CyborgdbServiceApiSchemasVectorsSuccessResponseModel.md)
 - [DeleteRequest](cyborgdb/openapi_client/docs/DeleteRequest.md)
 - [ErrorResponseModel](cyborgdb/openapi_client/docs/ErrorResponseModel.md)
 - [GetRequest](cyborgdb/openapi_client/docs/GetRequest.md)
 - [GetResponseModel](cyborgdb/openapi_client/docs/GetResponseModel.md)
 - [GetResultItemModel](cyborgdb/openapi_client/docs/GetResultItemModel.md)
 - [HTTPValidationError](cyborgdb/openapi_client/docs/HTTPValidationError.md)
 - [IndexConfig](cyborgdb/openapi_client/docs/IndexConfig.md)
 - [IndexIVFFlatModel](cyborgdb/openapi_client/docs/IndexIVFFlatModel.md)
 - [IndexIVFModel](cyborgdb/openapi_client/docs/IndexIVFModel.md)
 - [IndexIVFPQModel](cyborgdb/openapi_client/docs/IndexIVFPQModel.md)
 - [IndexInfoResponseModel](cyborgdb/openapi_client/docs/IndexInfoResponseModel.md)
 - [IndexListResponseModel](cyborgdb/openapi_client/docs/IndexListResponseModel.md)
 - [IndexOperationRequest](cyborgdb/openapi_client/docs/IndexOperationRequest.md)
 - [QueryRequest](cyborgdb/openapi_client/docs/QueryRequest.md)
 - [QueryResponse](cyborgdb/openapi_client/docs/QueryResponse.md)
 - [QueryResultItem](cyborgdb/openapi_client/docs/QueryResultItem.md)
 - [Request](cyborgdb/openapi_client/docs/Request.md)
 - [Results](cyborgdb/openapi_client/docs/Results.md)
 - [TrainRequest](cyborgdb/openapi_client/docs/TrainRequest.md)
 - [UpsertRequest](cyborgdb/openapi_client/docs/UpsertRequest.md)
 - [ValidationError](cyborgdb/openapi_client/docs/ValidationError.md)
 - [ValidationErrorLocInner](cyborgdb/openapi_client/docs/ValidationErrorLocInner.md)
 - [VectorItem](cyborgdb/openapi_client/docs/VectorItem.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="APIKeyHeader"></a>
### APIKeyHeader

- **Type**: API key
- **API key parameter name**: X-API-Key
- **Location**: HTTP header


## Author




